package com.vromtr.paad.ch8.whereami;

import android.app.Activity;
import android.os.Bundle;
import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.widget.TextView;

public class WhereAmI extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        //Call base class onCreate
    	super.onCreate(savedInstanceState);
        
    	//"Inflate" our UI (such as it is) from our program's resource
    	setContentView(R.layout.main);
    	
    	//Magic class for interacting with all the different ways
    	//a phone can stalk you.
    	LocationManager locationManager;
    	
    	//We have to ask for the systemwide instance of the LocationManager class nicely.
    	//This is the name we use to ask for it.
    	String context = Context.LOCATION_SERVICE;
    	
    	//We get the locationmanager by means of a Context
    	//I have no clue what a "context" is.  But it gets you stuff.
    	locationManager = (LocationManager)getSystemService(context);
    	
    	//Name we use to ask to talk to the GPS
    	String provider = LocationManager.GPS_PROVIDER;
    	
    	//Get last reported location from the GPS
    	//No guarantee that it was updated recently.
    	Location location = locationManager.getLastKnownLocation(provider);
    	
    	//Our method
    	//Update the UI
    	updateWithNewLocation(location);
    	
    	//Set up the listener to get location updates from the GPS
    	//The listener is triggered by polling the GPS, and the GPS proactively notifying our application of movements
    	int t = 5000;		//Poll the GPS every 5000 milliseconds
    	int distance = 1;	//Or update earlier if we've moved 1 meters
    	
    	LocationListener myLocationListener = new LocationListener()
    	{

			public void onLocationChanged(Location location) {
				updateWithNewLocation(location);
				
			}

			public void onProviderDisabled(String provider) {
				// TODO Auto-generated method stub
				
			}

			public void onProviderEnabled(String provider) {
				// TODO Auto-generated method stub
				
			}

			public void onStatusChanged(String provider, int status,
					Bundle extras) {
				// TODO Auto-generated method stub
				
			}
    		
    	};
    	
    	//Hook up our event handler^W^W listener to receive updates
    	locationManager.requestLocationUpdates(provider, t, distance, myLocationListener);
    	
    	
    }

	private void updateWithNewLocation(Location location) {
		
		//We will fill this in with the latitude/longitude from "location"
		String latLongString;
		
		//Reference to our TextView (the only real component of our UI)
		TextView myLocationText;
		
		//Get a handle to our textview
		myLocationText = (TextView)findViewById(R.id.myLocationText);
		
		//If we have a location, build the string
		if (location != null)
		{
			double lat = location.getLatitude();
			double lng = location.getLongitude();
			latLongString = "Lat: " + lat + "\nLong: " + lng;
		}
		else
		{
			latLongString = "No location found.";
		}
		
		myLocationText.setText("Your current position is totally around: \n"+latLongString);
		
		
	}
}